
;;; ncurses_const.scm

(define-public TRUE 1)
(define-public FALSE 0)

(define-public ERR -1)
(define-public OK 0)

(define-public COLOR_BLACK 0)
(define-public COLOR_RED 1)
(define-public COLOR_GREEN 2)
(define-public COLOR_YELLOW 3)
(define-public COLOR_BLUE 4)
(define-public COLOR_MAGENTA 5)
(define-public COLOR_CYAN 6)
(define-public COLOR_WHITE 7)

;;; /* values for the _flags member */
(define-public _SUBWIN #x01)
(define-public _ENDLINE #x02)
(define-public _FULLWIN #x04)
(define-public _SCROLLWIN #x08)
(define-public _ISPAD #x10)
(define-public _HASMOVED #x20)
(define-public _WRAPPED #x40)

(define-public _NOCHANGE -1)
(define-public _NEWINDEX -1)

;;; /* attributes */
(define-public A_NORMAL 0)
(define-public A_ATTRIBUTES 4294967040)
(define-public A_CHARTEXT 255)
(define-public A_COLOR 65280)
(define-public A_STANDOUT 65536)
(define-public A_UNDERLINE 131072)
(define-public A_REVERSE 262144)
(define-public A_BLINK 524288)
(define-public A_DIM 1048576)
(define-public A_BOLD 2097152)
(define-public A_ALTCHARSET 4194304)
(define-public A_INVIS 8388608)

(define-public A_PROTECT 16777216)
(define-public A_HORIZONTAL 33554432)
(define-public A_LEFT 67108864)
(define-public A_LOW 134217728)
(define-public A_RIGHT 268435456)
(define-public A_TOP 536870912)
(define-public A_VERTICAL 1073741824)

;;; Keycodes
(define-public KEY_CODE_YES #o400)
(define-public KEY_MIN #o401)
(define-public KEY_BREAK #o401)
(define-public KEY_DOWN #o402)
(define-public KEY_UP #o403)
(define-public KEY_LEFT #o404)
(define-public KEY_RIGHT #o405)
(define-public KEY_HOME #o406)
(define-public KEY_BACKSPACE #o407)
(define-public KEY_F0 #o410)

;;; Not from ncurses, but useful
;;; There are also (KEY_Fn n) function present
(define-public KEY_F1 #o410)
(define-public KEY_F2 #o410)
(define-public KEY_F3 #o410)
(define-public KEY_F4 #o410)
(define-public KEY_F5 #o410)
(define-public KEY_F6 #o410)
(define-public KEY_F7 #o410)
(define-public KEY_F8 #o410)
(define-public KEY_F9 #o410)
(define-public KEY_F10 #o410)
(define-public KEY_F11 #o410)
(define-public KEY_F12 #o410)

(define-public KEY_DL #o510)
(define-public KEY_IL #o511)
(define-public KEY_DC #o512)
(define-public KEY_IC #o513)
(define-public KEY_EIC #o514)
(define-public KEY_CLEAR #o515)
(define-public KEY_EOS #o516)
(define-public KEY_EOL #o517)
(define-public KEY_SF #o520)
(define-public KEY_SR #o521)
(define-public KEY_NPAGE #o522)
(define-public KEY_PPAGE #o523)
(define-public KEY_STAB #o524)
(define-public KEY_CTAB #o525)
(define-public KEY_CATAB #o526)
(define-public KEY_ENTER #o527)
(define-public KEY_SRESET #o530)
(define-public KEY_RESET #o531)
(define-public KEY_PRINT #o532)
(define-public KEY_LL #o533)

(define-public KEY_A1 #o534)
(define-public KEY_A3 #o535)
(define-public KEY_B2 #o536)
(define-public KEY_C1 #o537)
(define-public KEY_C3 #o540)
(define-public KEY_BTAB #o541)
(define-public KEY_BEG #o542)
(define-public KEY_CANCEL #o543)
(define-public KEY_CLOSE #o544)
(define-public KEY_COMMAND #o545)
(define-public KEY_COPY #o546)
(define-public KEY_CREATE #o547)
(define-public KEY_END #o550)
(define-public KEY_EXIT #o551)
(define-public KEY_FIND #o552)
(define-public KEY_HELP #o553)
(define-public KEY_MARK #o554)
(define-public KEY_MESSAGE #o555)
(define-public KEY_MOVE #o556)
(define-public KEY_NEXT #o557)
(define-public KEY_OPEN #o560)
(define-public KEY_OPTIONS #o561)
(define-public KEY_PREVIOUS #o562)
(define-public KEY_REDO #o563)
(define-public KEY_REFERENCE #o564)
(define-public KEY_REFRESH #o565)
(define-public KEY_REPLACE #o566)
(define-public KEY_RESTART #o567)
(define-public KEY_RESUME #o570)
(define-public KEY_SAVE #o571)
(define-public KEY_SBEG #o572)
(define-public KEY_SCANCEL #o573)
(define-public KEY_SCOMMAND #o574)
(define-public KEY_SCOPY #o575)
(define-public KEY_SCREATE #o576)
(define-public KEY_SDC #o577)
(define-public KEY_SDL #o600)
(define-public KEY_SELECT #o601)
(define-public KEY_SEND #o602)
(define-public KEY_SEOL #o603)
(define-public KEY_SEXIT #o604)
(define-public KEY_SFIND #o605)
(define-public KEY_SHELP #o606)
(define-public KEY_SHOME #o607)
(define-public KEY_SIC #o610)
(define-public KEY_SLEFT #o611)
(define-public KEY_SMESSAGE #o612)
(define-public KEY_SMOVE #o613)
(define-public KEY_SNEXT #o614)
(define-public KEY_SOPTIONS #o615)
(define-public KEY_SPREVIOUS #o616)
(define-public KEY_SPRINT #o617)
(define-public KEY_SREDO #o620)
(define-public KEY_SREPLACE #o621)
(define-public KEY_SRIGHT #o622)
(define-public KEY_SRSUME #o623)
(define-public KEY_SSAVE #o624)
(define-public KEY_SSUSPEND #o625)
(define-public KEY_SUNDO #o626)
(define-public KEY_SUSPEND #o627)
(define-public KEY_UNDO #o630)
(define-public KEY_MOUSE #o631)
(define-public KEY_RESIZE #o632)
(define-public KEY_MAX #o777)

(define-public NCURSES_MOUSE_VERSION 1)

;;; /* event masks */
(define-public BUTTON1_RELEASED #o1)
(define-public BUTTON1_PRESSED #o2)
(define-public BUTTON1_CLICKED #o4)
(define-public BUTTON1_DOUBLE_CLICKED #o10)
(define-public BUTTON1_TRIPLE_CLICKED #o20)
(define-public BUTTON1_RESERVED_EVENT #o40)
(define-public BUTTON2_RELEASED #o100)
(define-public BUTTON2_PRESSED #o200)
(define-public BUTTON2_CLICKED #o400)
(define-public BUTTON2_DOUBLE_CLICKED #o1000)
(define-public BUTTON2_TRIPLE_CLICKED #o2000)
(define-public BUTTON2_RESERVED_EVENT #o4000)
(define-public BUTTON3_RELEASED #o10000)
(define-public BUTTON3_PRESSED #o20000)
(define-public BUTTON3_CLICKED #o40000)
(define-public BUTTON3_DOUBLE_CLICKED #x8000)
(define-public BUTTON3_TRIPLE_CLICKED #x10000)
(define-public BUTTON3_RESERVED_EVENT #x20000)
(define-public BUTTON4_RELEASED #x40000)
(define-public BUTTON4_PRESSED #x80000)
(define-public BUTTON4_CLICKED #x100000)
(define-public BUTTON4_DOUBLE_CLICKED #x200000)
(define-public BUTTON4_TRIPLE_CLICKED #x400000)
(define-public BUTTON4_RESERVED_EVENT #x800000)
(define-public BUTTON_CTRL #x1000000)
(define-public BUTTON_SHIFT #x2000000)
(define-public BUTTON_ALT #x4000000)
(define-public ALL_MOUSE_EVENTS 134217727)
(define-public REPORT_MOUSE_POSITION 134217728)
